; use on expanded rom (2MB)
; map themes: $1E/F904

lorom

org $1ef904
	JSL track
	NOP

org $268093
	JML play
	NOP

org $26807A
	JSL setFade
	NOP

org $008A8E
	JSL nmi	
;------------------freespace
org $308000


track:
STA $1EEC; native code
STA $01
lda $2002
CMP #$53
BEQ $01
RTL
LDA $1EEC
CMP $7e1f42
BNE $01
RTL
STZ $2006
STA $2004
STA $7e1f42 ; track number flag
STZ $2005
RTL

play:
lda $2002
CMP #$53
BNE playspc
loop:
LDA #$00
STA $7e1f41
LDA $7e1f42
CMP $7e1f43
BEQ endplay
BIT $2000
BVS loop
lda $2000
AND #$08
BNE playspc ; error bit set?
LDA #$FF
STA $2006
STA $7e1f40 ;volume for fade
PHX
LDX #$0000
LDA $7e1f42
STA $7e1f43
TAX
LDA $308200,x
STA $2007
PLX
endplay:
LDA #$04
STA $2142
LDA #$07
STA $2141
JML $26809D
playspc:
LDA #$AA
STA $7e1f42 
LDA #$BB
STA $7e1f43 
LDA #$01
STA $2142
JML $268098

setFade:
LDA #$07
STA $2141
lda $2002
CMP #$53
BEQ $01
RTL
LDA #$AA
STA $7e1f42 
LDA #$BB
STA $7e1f43 
LDA #$01
STA $7e1f41 ; set fadeflag
RTL

nmi:
SEP #$30
LDA $7e1f41
CMP #$01
BEQ $03
LDA #$00
RTL
lda $7e1f40  ;current volume level
CMP #$00
beq zero
dec
dec
dec
cmp #$10 ; zero at 10
bcs $06
zero:
lda #$00
sta $7e1f41 ; zero flag
sta $2006
sta $7e1f40 ; new volume level
LDA #$00
RTL

org $308200 ; loop table
; Loop Table
; 01-Non-loop, 03-Loop
;   00  01  02  03  04  05  06  07  08  09  0A  0B  0C  0D  0E  0F
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$01,$03 ; themes 00-0f - 00
db $01,$03,$03,$03,$01,$03,$03,$03,$03,$03,$01,$01,$01,$01,$01,$01 ; themes 10-1f - 10
db $01,$01,$01,$01,$01,$01,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 20-2f - 20
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 30-3f - 30